﻿Imports System
Imports System.Drawing.Text
Imports System.Drawing
Imports System.IO

Public Class Form1

    Private Sub btnAplicarTexto_Click(sender As Object, e As EventArgs) Handles btnAplicarTexto.Click
        Try
            Dim x As Integer = Convert.ToInt32(txtX.Text)
            Dim y As Integer = Convert.ToInt32(txtY.Text)
            Dim tam As Integer = Convert.ToInt32(txtTamanho.Text)
            Dim NF As New Font(cboFontes.Text, tam, FontStyle.Bold)
            Dim NB As New SolidBrush(Color.FromArgb(64, 192, 255, 255))
            NB.Color = Color.FromArgb(128, 0, 0, 0)
            picImagem.CreateGraphics.DrawString(txtTexto.Text, NF, NB, x, y)
        Catch ex As Exception
            MessageBox.Show(ex.Message)
        End Try
    End Sub

    Private Sub btnCarregarImagem_Click(sender As Object, e As EventArgs) Handles btnCarregarImagen.Click
        Try
            Dim openfiledialog As New OpenFileDialog
            If openfiledialog.ShowDialog = DialogResult.OK Then
                picImagem.Image = Image.FromFile(openfiledialog.FileName)
            End If
        Catch ex As Exception
            MessageBox.Show(ex.Message)
        End Try
    End Sub
    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        carregarFontes()
    End Sub
    Private Sub carregarFontes()
        Try
            Dim fontes_Instaladas As New InstalledFontCollection
            cboFontes.Items.Clear()
            For Each font_family As FontFamily In fontes_Instaladas.Families
                cboFontes.Items.Add(font_family.Name)
            Next font_family
            cboFontes.SelectedIndex = 0
        Catch ex As Exception
            MessageBox.Show(ex.Message)
        End Try
    End Sub
    Private Sub DesenharMarcaDagua(ByVal bm_marcaDagua As Bitmap, ByVal bm_Resultado As Bitmap, ByVal x As Integer, ByVal y As Integer)
        Const ALPHA As Byte = 128
        ' Define o componente Alpha do pixel
        Dim clr As Color
        For py As Integer = 0 To bm_marcaDagua.Height - 1
            For px As Integer = 0 To bm_marcaDagua.Width - 1
                clr = bm_marcaDagua.GetPixel(px, py)
                bm_marcaDagua.SetPixel(px, py, Color.FromArgb(ALPHA, clr.R, clr.G, clr.B))
            Next px
        Next py

        ' Define a marca dagua como transparente
        bm_marcaDagua.MakeTransparent(bm_marcaDagua.GetPixel(0, 0))

        ' Copia o resultado na imagem
        Dim gr As Graphics = Graphics.FromImage(bm_Resultado)
        gr.DrawImage(bm_marcaDagua, x, y)
    End Sub

    Private Sub btnAplicarImagem_Click(sender As Object, e As EventArgs) Handles btnAplicarImagem.Click
        ' a imagem que será usada como marca d'agua
        Dim bm_marcaDagua As New Bitmap(picImagemMarcaDagua.Image)
        ' a imagem onde iremos aplicar a marca dágua
        Dim bm_Resultado As New Bitmap(picImagem.Image)

        'centraliza a marca d'agua
        If chkCentralizar.Checked Then
            Dim x As Integer = (bm_Resultado.Width - bm_marcaDagua.Width) \ 2
            Dim y As Integer = (bm_Resultado.Height - bm_marcaDagua.Height) \ 3
            DesenharMarcaDagua(bm_marcaDagua, bm_Resultado, x, y)
        Else
            'define a marca d'agua em uma posição especifica
            Dim x As Integer = Convert.ToInt32(txtX.Text)
            Dim y As Integer = Convert.ToInt32(txtY.Text)
            DesenharMarcaDagua(bm_marcaDagua, bm_Resultado, x, y)
        End If
        picImagem.Image = bm_Resultado
    End Sub

    Private Sub btnSalvarImagem_Click(sender As Object, e As EventArgs) Handles btnSalvarImagem.Click
        Try
            ' a imagem onde iremos aplicar a marca dágua
            Dim pic_Resultado As New Bitmap(picImagem.Image)
            svd1.ShowDialog()
            pic_Resultado.Save(svd1.FileName)
        Catch ex As Exception
            MessageBox.Show(ex.Message)
        End Try
    End Sub
End Class
